function aggregateV = aggregateQLearning(pAs,pPhi,pD)
    Q = zeros(size(pD,1),length(pAs));
    Q(1,:) = 1;
    steps = 1;
    c = 14 * size(pAs{1},1) ;%1 * 10^5;
    aggregateV = zeros(size(pD,1),0);
    rc = 1;
    eps = 0.1;
    
    %iterations = %10*10^5;
    
    while true
        x = 1 + randi(size(pD,1)-1);
        a = randi(length(pAs));
        
        [~,s] = simulate(pD,x);
        [r,sp] = simulate(pAs{a},s);        
        [~,xp] = simulate(pPhi,sp);       
                
        alpha = c/(c+steps);
                
        %%%assumes no discount (gamma = 1)
        Q(x,a) = (1 - alpha) * Q(x,a) + alpha * (r + max (Q(xp,:)));
        
        if (mod(steps,10000) == 0)            
            aggregateV(:,rc) = max(Q,[],2);
            diff = norm(aggregateV(:,rc) - aggregateV(:,max(1,rc-1)));
            fprintf('%d(%.2f) ', steps, diff);
            if rc >= 2 && diff < eps;
               break;
            end
            rc = rc + 1;
        end
        steps = steps + 1;
    end
    fprintf('\n');
    %aggregateV = max(Q,[],2);
end

function [r,sp] = simulate(model,s)
    r = model(s,1);
    %assert(abs(sum(model(s,2:end)) - 1) < 0.0001);
    sp = 1 + find(rand < cumsum(model(s,2:end)),1);
end